package ru.dbotthepony.mc.otm.config

import net.minecraftforge.common.ForgeConfigSpec
import net.minecraftforge.fml.ModLoadingContext
import net.minecraftforge.fml.config.ModConfig
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.core.util.WriteOnce

abstract class AbstractConfig(private val configName: String, private val type: ModConfig.Type = ModConfig.Type.SERVER) {
	private var spec: ForgeConfigSpec by WriteOnce()
	protected val builder = ForgeConfigSpec.Builder()
	private var registered = false

	fun register() {
		check(!registered) { "Already registered config" }
		registered = true
		spec = builder.build()
		ModLoadingContext.get().registerConfig(type, spec, "${OverdriveThatMatters.MOD_ID}-$configName.toml")
	}
}
